#include <Servo.h> 

const int SERVOS = 4; //서보모터 갯수
//각 배열 생성
int PIN[SERVOS], value[SERVOS], idle[SERVOS], currentAngle[SERVOS], MIN[SERVOS];
int MAX[SERVOS], INITANGLE[SERVOS], previousAngle[SERVOS], ANA[SERVOS];
Servo myservo[SERVOS]; //서보모터 객체 생성, 배열

void setup()   {
  //좌우회전 서보모터
  PIN[0] = 9; //서보모터 IO를 9번핀으로 지정
  MIN[0] = 10; //서보모터 최소 회전각도
  MAX[0] = 170; //서보모터 최대 회전각도
  INITANGLE[0] = 90; //서보모터 초기각도
  ANA[0] = 0; //좌측 조이스틱 x축
  //왼쪽 서보모터
  PIN[1] = 6;
  MIN[1] = 20; 
  MAX[1] = 170;
  INITANGLE[1] = 110;
  ANA[1] = 1; // 좌측 조이스틱 y축
  //오른쪽 서보모터
  PIN[2] = 5;
  MIN[2] = 10;
  MAX[2] = 170;
  INITANGLE[2] = 90;
  ANA[2] = 2; // 우측 조이스틱 y축
  //그립퍼 서보모터
  PIN[3] = 10;
  MIN[3] = 40;
  MAX[3] = 160;
  INITANGLE[3] = 110;
  ANA[3] = 3; // 우측 조이스틱 x축
  
  for (int i = 0; i < SERVOS; i++){
    myservo[i].attach(PIN[i]); //서보모터 활성화
    myservo[i].write(INITANGLE[i]); //서보모터 초기각도 적용
    value[i] = 0;
    idle[i] = 0;
    previousAngle[i]=INITANGLE[i];
  }
}

void loop() {
  delay(20); // 로봇팔 속도조정을 위한 딜레이
 
    for (int i = 0; i < SERVOS; i++){
      value[i] = analogRead(ANA[i]);
      currentAngle[i] = myservo[i].read();
      Serial.print(currentAngle[i]);
      Serial.print(" ");
    
      if (value[i] > 612) {
        idle[i] = 0;
        if (currentAngle[i] < MAX[i]){
          ++currentAngle[i];
        }
        if (!myservo[i].attached()){
          myservo[i].attach(PIN[i]);
        }
        myservo[i].write(currentAngle[i]);     
      } else if (value[i] < 412) {
        idle[i] = 0;
        if (currentAngle[i] > MIN[i]){
          --currentAngle[i];
        }
        if (!myservo[i].attached()){
          myservo[i].attach(PIN[i]);
        }
      myservo[i].write(currentAngle[i]);    
    } else {
      ++idle[i];
    }
    if (idle[i] > 100){
      myservo[i].detach(); //서보모터를 일정시간 사용하지 않으면 연결을 끊어둔다.
      idle[i] = 0;
    }  
  }
}
